package com.fp.persistence.pgeneral.safe;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TSAFEAUDIT*/
@Entity(name="TsafeAudit")
@Table(name="TSAFEAUDIT")
public class TsafeAudit extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TsafeAudit
*/
@EmbeddedId
private TsafeAuditKey pk;
@Column(name="COMPANYCODE", nullable=false)

/**
* Codigo de compania al que pertenece la oficina
*/
private Integer companycode;

@Column(name="OFFICECODE", nullable=true)

/**
* Codigo de oficina
*/
private Integer officecode;

@Column(name="BRANCHCODE", nullable=true)

/**
* Codigo de sucursal
*/
private Integer branchcode;

@Column(name="TERMINALCODE", nullable=true)

/**
* Codigo de terminal
*/
private String terminalcode;

@Column(name="USERCODE", nullable=false)

/**
* Codigo de usuario
*/
private String usercode;

@Column(name="TRANSACTIONMODULE", nullable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="OLDVALUE", nullable=true)

/**
* Valor anterior del campo
*/
private String oldvalue;

@Column(name="NEWVALUE", nullable=true)

/**
* Nuevo valor del campo
*/
private String newvalue;

@Column(name="ACCOUNT", nullable=true)

/**
* Numero de cuenta que se afecta
*/
private String account;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona asociada a la tabla que se modifica
*/
private Integer personcode;

@Column(name="SOLICITUDENUMBER", nullable=true)

/**
* Numero de solicitud asociada a la tabla que se modifica.
*/
private String solicitudenumber;

@Column(name="BROWSER", nullable=true)

/**
* Ingresa la informacion del browser.
*/
private String browser;

@Column(name="OPERATIVSYSTEM", nullable=true)

/**
* Ingresa la informacion del sistema operativo.
*/
private String operativesystem;

/**Contructor por defecto*/
public TsafeAudit(){
}
/**Contructor de TsafeAudit
@param pPk Clave Primaria del entity
@param pCompanycode Codigo de compania al que pertenece la oficina
@param pUsercode Codigo de usuario
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
*/
public TsafeAudit(TsafeAuditKey pPk,Integer pCompanycode,String pUsercode,String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion){
 this();
 pk=pPk;
 companycode=pCompanycode;
 usercode=pUsercode;
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TsafeAudit
*/
public static TsafeAudit find(EntityManager pEntityManager,TsafeAuditKey pKey) throws Exception{
    TsafeAudit obj = pEntityManager.find(TsafeAudit.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TsafeAudit
@return El objeto que referencia a la Clave primaria de TsafeAudit
*/
public TsafeAuditKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TsafeAudit
@param pPk El objeto que referencia a la nueva Clave primaria de TsafeAudit
*/
public void setPk(TsafeAuditKey pPk){
  pk=pPk;
}
/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Obtiene el valor de officecode
@return valor de officecode*/
public Integer getOfficecode(){
  return officecode;
}
/**Fija el valor de officecode
@param pOfficecode nuevo Valor de officecode*/
public void setOfficecode(Integer pOfficecode){
  officecode=pOfficecode;
}

/**Obtiene el valor de branchcode
@return valor de branchcode*/
public Integer getBranchcode(){
  return branchcode;
}
/**Fija el valor de branchcode
@param pBranchcode nuevo Valor de branchcode*/
public void setBranchcode(Integer pBranchcode){
  branchcode=pBranchcode;
}

/**Obtiene el valor de terminalcode
@return valor de terminalcode*/
public String getTerminalcode(){
  return terminalcode;
}
/**Fija el valor de terminalcode
@param pTerminalcode nuevo Valor de terminalcode*/
public void setTerminalcode(String pTerminalcode){
  terminalcode=pTerminalcode;
}

/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de oldvalue
@return valor de oldvalue*/
public String getOldvalue(){
  return oldvalue;
}
/**Fija el valor de oldvalue
@param pOldvalue nuevo Valor de oldvalue*/
public void setOldvalue(String pOldvalue){
  oldvalue=pOldvalue;
}

/**Obtiene el valor de newvalue
@return valor de newvalue*/
public String getNewvalue(){
  return newvalue;
}
/**Fija el valor de newvalue
@param pNewvalue nuevo Valor de newvalue*/
public void setNewvalue(String pNewvalue){
  newvalue=pNewvalue;
}

/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de solicitudenumber
@return valor de solicitudenumber*/
public String getSolicitudenumber(){
  return solicitudenumber;
}
/**Fija el valor de solicitudenumber
@param pSolicitudenumber nuevo Valor de solicitudenumber*/
public void setSolicitudenumber(String pSolicitudenumber){
  solicitudenumber=pSolicitudenumber;
}
/**Obtiene el valor de browser
@return valor de browser*/
public String getBrowser() {
	return browser;
}
/**Fija el valor de browser
@param pBrowser nuevo Valor de browser*/
public void setBrowser(String pBrowser) {
	this.browser = pBrowser;
}
/**Obtiene el valor de operativesystem
@return valor de operativesystem*/
public String getOperativesystem() {
	return operativesystem;
}
/**Fija el valor de operativesystem
@param pOperativesystem nuevo Valor de operativesystem*/
public void setOperativesystem(String pOperativesystem) {
	this.operativesystem = pOperativesystem;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TsafeAudit))return false;
    TsafeAudit that = (TsafeAudit) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TsafeAudit
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TsafeAudit
*/
public Object createInstance(){
 TsafeAudit instance=new TsafeAudit();	
 instance.setPk(new TsafeAuditKey());
 return instance;
}
/**Clona la entidad TsafeAudit
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TsafeAudit p=(TsafeAudit)this.clone();
  p.setPk((TsafeAuditKey)this.pk.cloneMe());
  return p;
}
}
